'IDE-Voreinstellungen:
'Option Explicit On
'Option Strict On

'"My Project"-Einstellungen:
'Imports Microsoft.VisualBasic.ControlChars
'Imports System.Windows.Forms

Public Class Form1

   Private WithEvents _Memory As New ComplexConverter

   Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
      ' My.Settings.Memory ist in den Anwendungseinstellungen eingerichtet
      ' wichtig: "Eigene Einstellungen beim Herunterfahren speichern" aktivieren!
      _Memory.ApplyDataString(My.Settings.Memory)
      ' RichTextBox nur zur Veranschaulichung - eigentlich nicht erforderlich
      RichTextBox1.Text = My.Settings.Memory
   End Sub

   Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) _
           Handles Me.FormClosing
      My.Settings.Memory = _Memory.CreateDataString()
   End Sub

   ''' <summary>komplexe Konvertierung fr dieses Form</summary>
   Private Sub _Memory_Convert(ByVal sender As Object, ByVal e As ComplexConverter.EventArg) _
           Handles _Memory.Convert
      ' Form-Properties konvertieren
      e.ConvertValue(Me.WindowState)
      e.ConvertValue(Me.Bounds)
      ' Treeview konvertieren
      EnumerateNodes(TreeView1.Nodes, e)
      ' ListView-Spaltenbreiten konvertieren
      For Each Col As ColumnHeader In Me.ListView1.Columns
         e.ConvertValue(Col.Width)
      Next
      ' ListView-Items konvertieren
      e.ConvertList(Of ListViewItem)(ListView1.Items)
      For Each LVI As ListViewItem In ListView1.Items
         ' ListView-SubItems konvertieren
         e.ConvertList(Of ListViewItem.ListViewSubItem)(LVI.SubItems)
         For Each LVSI As ListViewItem.ListViewSubItem In LVI.SubItems
            e.ConvertValue(LVSI.Text)
         Next
      Next
   End Sub

   Private Sub EnumerateNodes(ByVal Nodes As TreeNodeCollection, ByVal e As ComplexConverter.EventArg)
      e.ConvertList(Of TreeNode)(Nodes)
      For Each Nd As TreeNode In Nodes
         e.ConvertValue(Nd.Text)
         EnumerateNodes(Nd.Nodes, e)
         ' Workaround, da Treenode.IsExpanded readonly, also nicht direkt restaurierbar
         If e.IsStoring Then
            e.ConvertValue(Nd.IsExpanded)
         Else
            If e.GetValue(Of Boolean)() Then Nd.Expand()
         End If
      Next
   End Sub

   Private Sub Button_Click(ByVal sender As Object, ByVal e As EventArgs) Handles _
           btRead.Click, btWrite.Click, btAddNode.Click, btRemoveNode.Click, _
           btAddLVItem.Click, btRemoveListViewItem.Click
      Select Case True
         Case sender Is btRead
            _Memory.ApplyDataString(RichTextBox1.Text)
         Case sender Is btWrite
            RichTextBox1.Text = _Memory.CreateDataString
         Case sender Is btAddNode
            Dim Nd As TreeNode = TreeView1.SelectedNode
            If Nd Is Nothing Then
               TreeView1.Nodes.Add("NewNode")
            Else
               Nd.Nodes.Add("NewNode")
               Nd.Expand()
            End If
         Case sender Is btRemoveNode
            Dim Nd As TreeNode = TreeView1.SelectedNode
            If Nd Is Nothing Then
               MessageBox.Show("Select a Node to remove")
            Else
               Nd.Remove()
            End If
         Case sender Is btAddLVItem
            Dim N As Integer = ListView1.Items.Count
            Dim LVI As ListViewItem = ListView1.Items.Add(String.Concat(N, "1"))
            For I As Integer = 2 To ListView1.Columns.Count
               LVI.SubItems.Add(String.Concat(N, I))
            Next
         Case sender Is btRemoveListViewItem
            With ListView1.SelectedItems
               If .Count = 0 Then
                  MessageBox.Show("Select a ListViewItem to remove")
               Else
                  ListView1.Items.RemoveAt(.Item(0).Index)
               End If
            End With
      End Select
   End Sub
End Class
