﻿Imports System.ComponentModel

Public Class frmDgv

   Private WithEvents _Memory As New ComplexConverter

   Public Sub New()
      InitializeComponent()
      Dgv.ColumnCount = 8
      If Not _Memory.ApplyDataString(My.Settings.DgvMemory) Then
         Dgv.RowCount = 6
         For x = 0 To Dgv.ColumnCount - 1
            Dgv.Columns(x).HeaderText = x.ToString
            For y = 0 To Dgv.RowCount - 2
               Dgv(x, y).Value = (y + x * 10).ToString("00")
            Next
         Next
      End If
   End Sub

   Private Sub _Memory_Convert(sender As Object, e As ComplexConverter.EventArg) Handles _Memory.Convert
      e.ConvertValue(Me.Bounds, Dgv.RowCount)
      For Each col As DataGridViewColumn In Dgv.Columns
         e.ConvertValue(col.DisplayIndex, col.Width, col.HeaderText) ' bis zu 4 Werte in eim Aufruf persisteable
      Next
      For Each rw As DataGridViewRow In Dgv.Rows
         e.ConvertValue(rw.Height)
      Next
      For x = 0 To Dgv.ColumnCount - 1
         For y = 0 To Dgv.RowCount - 2
            e.ConvertExplicitTyped(Of String)(Dgv(x, y).Value)
         Next
      Next
      Dim order = Dgv.SortOrder
      Dim sortCol = If(order = SortOrder.None, -1, Dgv.SortedColumn.Index)
      e.ConvertValue(order, sortCol)
      If Not e.IsStoring Then
         If order <> SortOrder.None Then Dgv.Sort(Dgv.Columns(sortCol), DirectCast(order - 1, ListSortDirection))
      End If
   End Sub

   Private Sub frmDgv_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
      My.Settings.DgvMemory = _Memory.CreateDataString
   End Sub

   Private Sub btClearSettings_Click(sender As Object, e As EventArgs) Handles btClearSettings.Click
      My.Settings.DgvMemory = Nothing
      RemoveHandler Me.FormClosing, AddressOf frmDgv_FormClosing
      System.Media.SystemSounds.Asterisk.Play()
   End Sub

End Class